#include <bits/stdc++.h>

#include "tunnels.h"

struct node;
void pull(node* curr);

struct node {
    int32_t d; int32_t min; int32_t max;
    node* l; node* r;

    node(const int64_t cell = -1, const int64_t d = -1e9) :
        d(d), min(1e9), max(-1e9), l(nullptr), r(nullptr) {
        if (cell != -1) {
            min = cell;
            max = cell;
        }
    }

    node(node* l, node* r) :
        d(-1e9), min(1e9), max(-1e9), l(l), r(r) {
        pull(this);
    }
};

void pull(node* curr) {
    if (curr->l) {
        curr->min = curr->l->min;
        curr->d = std::max(curr->d, curr->l->d + 1);
    }
    if (curr->r) {
        curr->max = curr->r->max;
        curr->d = std::max(curr->d, curr->r->d + 1);
    }
}

std::vector<node> allNodes;

void solve(
    int n,
    int m,
    int k,
    const std::vector<std::vector<bool>>& blocked
) {
    allNodes.resize(2 * m);
    std::vector<int> finalTreeDepth(n * m, -1);
    std::vector<node> st;
    st.reserve(m);

    const auto buildTree = [&] (const int64_t row, const int64_t l, const int64_t r) -> node* {
        allNodes.resize(0);
        st.resize(0);
        int64_t delta = 0;

        for (int64_t i = l; i <= r; i ++) {
            int64_t treeD;
            if (row == n - 1) {
                treeD = 0;
            } else if (blocked[row + 1][i] || finalTreeDepth[(row + 1) * m + i] == -1) {
                continue;
            } else {
                treeD = finalTreeDepth[(row + 1) * m + i];
            }
            node curr(i, treeD);
            while (st.size() >= 2 && st[st.size() - 2].d <= curr.d) {
                allNodes.push_back(st[st.size() - 2]); allNodes.push_back(st[st.size() - 1]);
                st.pop_back();
                new (&st.back()) node(&allNodes[allNodes.size() - 2], &allNodes[allNodes.size() - 1]);
                while (st.size() >= 2 && st[st.size() - 2].d == st[st.size() - 1].d) {
                    allNodes.push_back(st[st.size() - 2]); allNodes.push_back(st[st.size() - 1]);
                    st.pop_back();
                    new (&st.back()) node(&allNodes[allNodes.size() - 2], &allNodes[allNodes.size() - 1]);
                }
            }
            st.push_back(curr);
            while (st.size() >= 2 && st[st.size() - 2].d <= st[st.size() - 1].d) {
                allNodes.push_back(st[st.size() - 2]); allNodes.push_back(st[st.size() - 1]);
                st.pop_back();
                new (&st.back()) node(&allNodes[allNodes.size() - 2], &allNodes[allNodes.size() - 1]);
            }
        }

        while (st.size() >= 2) {
            allNodes.push_back(st[st.size() - 2]); allNodes.push_back(st[st.size() - 1]);
            st.pop_back();
            new (&st.back()) node(&allNodes[allNodes.size() - 2], &allNodes[allNodes.size() - 1]);
        }

        if (st.empty()) {
            return nullptr;
        } else {
            allNodes.push_back(st.back()); st.pop_back();
            return &allNodes.back();
        }
    };

    for (int64_t i = n - 1; i >= 0; i --) {
        int64_t curr = 0;
        while (curr < m) {
            const auto start = curr;
            while (!blocked[i][curr] && curr < m) {
                curr ++;
            }
            const auto tree = buildTree(i, start, curr - 1);
            if (!tree) {
                curr ++;
                continue;
            }
            const auto d = tree->d;
            for (int64_t j = start; j < curr; j ++) {
                finalTreeDepth[i * m + j] = d;
            }
            curr ++;
        }
    }

    for (int64_t i = 0; i < n; i ++) {
        int64_t l = k;
        while (l - 1 >= 0 && !blocked[i][l - 1]) { l --; }
        int64_t r = k;
        while (r + 1 < m && !blocked[i][r + 1]) { r ++; }
        node* curr = buildTree(i, l, r);
        while (true) {
            if (curr->min == curr->max) {
                k = curr->min;
                goDeeper(curr->min);
                break;
            }
            if (!curr->l && !curr->r) {
                assert(false);
            } else if (!curr->l || curr->l->min < 0) {
                curr = curr->r;
            } else if (!curr->r || curr->r->min < 0) {
                curr = curr->l;
            } else {
                if (k <= curr->l->max) {
                    if (investigate(curr->r->min)) {
                        curr = curr->r;
                    } else {
                        curr = curr->l;
                    }
                } else {
                    if (investigate(curr->l->max)) {
                        curr = curr->l;
                    } else {
                        curr = curr->r;
                    }
                }
            }
        }
    }
}

void goDeeper(int s);
bool investigate(int s);
